"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var promiseEx = require("./promiseEx");
var cargando = require("./cargando");
/**Devuelve true si un objeto es una promesa */
function IsPromise(value) {
    return value != null && (typeof value.then === 'function');
}
var disableObsoleteLog = "_disableObsoleteLog";
/**Muestra un componente que depende del valor de una promesa */
var Async = /** @class */ (function (_super) {
    __extends(Async, _super);
    function Async(props) {
        var _this = _super.call(this, props) || this;
        _this.currentVersion = 0;
        _this.refreshPromise = function (promise) { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            var currentVersion_1, minDelay, race, stateChange_1, result, stateChange_2, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 3, , 4]);
                        currentVersion_1 = this.currentVersion + 1;
                        this.currentVersion = currentVersion_1;
                        minDelay = this.props.delay == null ? 500 : this.props.delay;
                        return [4 /*yield*/, Promise.race([promiseEx.Delay(minDelay).then(function () { return "_delay"; }), promise])];
                    case 1:
                        race = _a.sent();
                        if (race == "_delay") {
                            stateChange_1 = { Cargando: true, Error: null };
                            this.setState(function (prev) { return _this.currentVersion == currentVersion_1 ? stateChange_1 : {}; });
                        }
                        return [4 /*yield*/, promise];
                    case 2:
                        result = _a.sent();
                        if (this._isMounted) {
                            stateChange_2 = {
                                Model: result,
                                Cargando: false,
                                Error: null
                            };
                            this.setState(function (prev) { return _this.currentVersion == currentVersion_1 ? stateChange_2 : {}; });
                        }
                        return [3 /*break*/, 4];
                    case 3:
                        err_1 = _a.sent();
                        console.error("Async component error: ");
                        console.error(err_1);
                        if (this._isMounted) {
                            this.setState({
                                Model: null,
                                Cargando: false,
                                Error: err_1
                            });
                        }
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        }); };
        _this.state = { Cargando: true };
        if (!props[disableObsoleteLog]) {
            console.warn("Utilice la función async en lugar del componente Async, ya que la función esta tipada");
        }
        return _this;
    }
    Async.prototype.componentWillMount = function () {
        this._isMounted = true;
        //Actualizamos el valor
        this.updateValue(this.props.value);
    };
    Async.prototype.updateValue = function (nextValue) {
        if (IsPromise(nextValue)) {
            this.refreshPromise(nextValue);
        }
        else {
            this.setState({ Model: nextValue, Cargando: false, Error: null });
        }
    };
    Async.prototype.componentWillReceiveProps = function (nextProps) {
        var nextValue = nextProps.value;
        var lastValue = this.props.value;
        if (nextValue != lastValue) {
            this.updateValue(nextProps.value);
        }
    };
    Async.prototype.componentWillUnmount = function () {
        this._isMounted = false;
    };
    Object.defineProperty(Async.prototype, "CargandoComponent", {
        get: function () {
            return (this.props.cargando !== undefined) ? this.props.cargando : React.createElement(cargando.Spinner, null);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Async.prototype, "ErrorComponent", {
        get: function () {
            return (this.props.error !== undefined) ? this.props.error(this.state.Error) : React.createElement("label", { style: { color: "red" } }, "Error: " + this.state.Error);
        },
        enumerable: true,
        configurable: true
    });
    Async.prototype.render = function () {
        var childComponent = (!this.state.Error && !this.state.Cargando) &&
            this.props.map(this.state.Model);
        return this.state.Error != null ? this.ErrorComponent :
            this.state.Cargando ? this.CargandoComponent :
                (childComponent || null);
    };
    return Async;
}(React.PureComponent));
exports.Async = Async;
/**Muestra un componente basado en el resultado de una promesa
 * @param value Promesa que se va a resolver para mostrar el componente
 * @param map Función que toma el resultado de la promesa y devuelve el componente que se desea dibujar
 */
function async(value, map, options) {
    var props = __assign({}, (options || {}), (_a = { value: value, map: map }, _a[disableObsoleteLog] = true, _a));
    return React.createElement(Async, __assign({}, props));
    var _a;
}
exports.async = async;
/**
 * Muestra un componente basado en el resultado ya sea resuelto, pendiente o erroneo de una promesa
 * @param value Promesa
 * @param map Funcion que mapea el estado de la promesa a un componente de real
 */
function asyncProps(value, map) {
    return async(value, function (x) { return map({ status: "done", value: x }); }, {
        cargando: map({ status: "pending" }),
        error: function (err) { return map({ status: "error", error: err }); }
    });
}
exports.asyncProps = asyncProps;
/**Crea una nueva promesa y devuelve por separado la promesa y las funciones que resuelven y rechazan a la promesa */
function splitPromise() {
    var resolve = null;
    var reject = null;
    var promise = new Promise(function (promResolve, promReject) {
        resolve = promResolve;
        reject = promReject;
    });
    return { promise: promise, resolve: resolve, reject: reject };
}
exports.splitPromise = splitPromise;
/**Crea una promesa que se resuelve en cierto tiempo */
function delay(milliseconds) {
    return new Promise(function (resolve) { return window.setTimeout(resolve, milliseconds); });
}
exports.delay = delay;
/**Aplica una función a cada propiedad de un objeto y devuelve un nuevo objeto con las mismas propiedades pero transformadas por la funcion dada */
function mapObject(obj, map) {
    var ret = {};
    for (var key in obj) {
        ret[key] = map(obj[key], key);
    }
    return ret;
}
