"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
/**Acomoda un conjunto de elementos en un <div /> con varios <div class="row" /> y <div class="col-md-x" /> que tendran a los elementos dados.
 * Los elementos nulos, undefined o false seran ignorados
 */
function autogrid(columnSize, elements) {
    //Quitar los elementos nulos y falsos
    elements = elements.filter(function (x) { return x; });
    var maxColumns = 12;
    var columnsPerRow = Math.floor(maxColumns / columnSize);
    var rows = Math.ceil(elements.length / columnsPerRow);
    var ret = [];
    var columnClass = "col-md-" + columnSize;
    var index = 0;
    for (var row = 0; row < rows; row++) {
        var children = [];
        for (var column = 0; column < columnsPerRow; column++) {
            var currentColumn = React.createElement("div", { className: columnClass }, elements[index]);
            children.push(currentColumn);
            index++;
        }
        var currentRow = React.createElement.apply(React, __spread(["div", { className: "row" }], children));
        ret.push(currentRow);
    }
    return React.createElement.apply(React, __spread(["div", {}], ret));
}
exports.autogrid = autogrid;
