/// <reference types="react" />
import React = require("react");
export declare type ChartType = "pie" | "doughnut" | "bar" | "line";
export interface ChartSeries {
    values: number[];
    title?: string;
    /**Arreglo de colores css */
    colors?: string[] | string;
}
export interface ChartData {
    type: ChartType;
    series: ChartSeries[];
    labels: string[];
}
export interface ChartComponentProps {
    value: ChartData;
    style?: React.CSSProperties;
}
/**Una gráfica que soporta varias series y varios tipos de gráficas*/
export declare class Chart extends React.PureComponent<ChartComponentProps, {}> {
    private onCanvasInit;
    private destroyChart();
    private updateChartData(props);
    canvas: HTMLCanvasElement;
    chart: any;
    componentWillUpdate(props: ChartComponentProps): void;
    render(): JSX.Element;
}
export interface SimpleChartValue {
    label: string;
    value: number;
}
export interface SimpleChartProps {
    /**Tipo de la gráfica. Por default es 'doughnut' */
    type?: ChartType;
    /**Valores de la gráfica */
    values: SimpleChartValue[];
    /**Arreglo de colores */
    colors?: string[];
}
/**Gráfica que soporta sólo una serie de información */
export declare class SimpleChart extends React.PureComponent<SimpleChartProps, {}> {
    render(): JSX.Element;
}
export interface HistogramChartProps {
    values: (string | number)[];
    sort?: (a: string, b: string) => number;
}
/**Una gráfica que devuelve la cantidad de elemento repetidos */
export declare class HistogramChart extends React.PureComponent<HistogramChartProps, {}> {
    render(): JSX.Element;
}
