/**local storage service interface */
export interface CookieService {
    Set(name: string, value: any): any;
    Get(name: string): any;
    Remove(name: string): any;
    Clear(): any;
}
/**
 * Servicio para almacenar datos en los cookies o en el localstorage
 */
export declare class CookieLocalStorageClass implements CookieService {
    private localstorage;
    private serialize;
    /**
     * @param localstorage True para usar el localstorage, false para usar los cookies
     * @param serialize True para serializar el value
     */
    constructor(localstorage: boolean, serialize: boolean);
    /**Limpia todos los valores */
    Clear(): void;
    /**Store a key-value pair */
    Set(name: string, value: any): void;
    /**Get a value by its key. Returns null if the value is not found */
    Get(name: string): any;
    /**Remove a value by its key */
    Remove(name: string): void;
}
/**Servicio de cookies por default */
export declare let Cookies: CookieLocalStorageClass;
/**Memoriza una función en los cookies */
export declare function cookieNetworkMemoize<T extends (...args: any[]) => Promise<any>>(func: T, cookieKey: string): T;
