export interface CrudResource<T> {
    query: () => PromiseLike<T[]>;
    get: (id: number) => PromiseLike<T>;
    delete: (id: number) => PromiseLike<void>;
    post: (x: T) => PromiseLike<number>;
    put: (x: T) => PromiseLike<void>;
}
/**Devuelve un objeto con las funciones para realizar operaciones crud sencilas sobre un recurso REST
 * @param url La url sin la última diagonal
 * @param key Nombre de la propiedad de la llave primaria que se usara en el put/update
 */
export declare function crud<TEntity extends {
    IdRegistro?: number | string | null;
}>(url: string): CrudResource<TEntity>;
export declare function crud<TEntity>(url: string, key: keyof TEntity): CrudResource<TEntity>;
