"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_rxk_1 = require("react-rxk");
var keautils_1 = require("keautils");
var FieldError = /** @class */ (function (_super) {
    __extends(FieldError, _super);
    function FieldError() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FieldError.prototype.render = function () {
        var props = this.props;
        var error = props.error;
        var text = typeof error == "string" ? error : "";
        return this.props.error ? React.createElement("span", { className: "label label-danger pull-right" },
            React.createElement("i", { className: "fa fa-time" }),
            text,
            " ") : null;
    };
    return FieldError;
}(React.PureComponent));
var FieldErrorRx = react_rxk_1.componentToRx(FieldError);
var FieldLabel = /** @class */ (function (_super) {
    __extends(FieldLabel, _super);
    function FieldLabel() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FieldLabel.prototype.render = function () {
        return (React.createElement("span", null,
            this.props.label,
            React.createElement(FieldErrorRx, { error: this.props.error })));
    };
    return FieldLabel;
}(React.PureComponent));
/**Un campo de una ventana con un label y un hijo de edición */
var FormField = /** @class */ (function (_super) {
    __extends(FormField, _super);
    function FormField() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FormField.prototype.render = function () {
        var label = this.props.label && ((typeof this.props.label == "string") ? React.createElement("label", null, this.props.label) : this.props.label);
        return (label ?
            (React.createElement("div", { className: "form-group " },
                React.createElement(FieldLabel, __assign({}, this.props, { error: keautils_1.toObservable(this.props.error) })),
                this.props.children)) : (this.props.children || null));
    };
    return FormField;
}(React.PureComponent));
exports.FormField = FormField;
