"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var Field = require("./formField");
var text_1 = require("./text");
var keautils_1 = require("keautils");
var HourMinuteComponent = /** @class */ (function (_super) {
    __extends(HourMinuteComponent, _super);
    function HourMinuteComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HourMinuteComponent.prototype.render = function () {
        var _this = this;
        var props = this.props;
        // const maxMinutes = props.hours && props.max ? Math.min(59, (props.max - props.hours) * 60) : 59;
        return (React.createElement("div", { style: { display: "flex" } },
            React.createElement("div", { style: { flex: "1 0 0" } },
                React.createElement(text_1.Text, { isReadOnly: props.readonly, value: keautils_1.formatNumber(props.hours, 2), onChange: function (x) { return _this.props.onChange({
                        hours: x ? Math.min(Math.max(parseInt(x), 0), 23) : null,
                        minutes: _this.props.minutes
                    }); }, disableFastInput: true })),
            React.createElement("div", { style: { flex: "1 0 0" } },
                React.createElement(text_1.Text, { isReadOnly: props.readonly, value: keautils_1.formatNumber(props.minutes, 2), onChange: function (x) { return _this.props.onChange({
                        hours: _this.props.hours,
                        minutes: x ? Math.min(Math.max(parseInt(x), 0), 59) : null
                    }); }, disableFastInput: true }))));
    };
    return HourMinuteComponent;
}(React.PureComponent));
exports.HourMinuteComponent = HourMinuteComponent;
var Hours = /** @class */ (function (_super) {
    __extends(Hours, _super);
    function Hours() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleOnChange = function (value) {
            if (_this.props.onChange) {
                var horas = value.hours || 0;
                var minutos = value.minutes || 0;
                var valor = (horas + (minutos / 60.0));
                _this.props.onChange(valor);
            }
        };
        return _this;
    }
    Hours.prototype.render = function () {
        var value = this.props.value;
        var hours = ((value != null) && (value < 0 ? Math.ceil(value) : Math.floor(value))) || 0;
        var minutes = ((value != null) && (hours != null) && Math.round(value * 60 - hours * 60)) || 0;
        return (React.createElement(Field.FormField, { label: this.props.label, error: this.props.error },
            React.createElement(HourMinuteComponent, { hours: hours, minutes: minutes, onChange: this.handleOnChange, readonly: this.props.readonly, min: this.props.min || 0, max: this.props.max || 24 })));
    };
    return Hours;
}(React.PureComponent));
exports.Hours = Hours;
