/// <reference types="react" />
import * as React from "react";
import * as val from "./validation";
/**Toma los props de un form y devuelve una función que convierte cualquier componente editor de un valor a uno que ya este ligado a un campo de ese form. Ejemplo
 * const getField =  formFieds(miValor, miOnChange, miErrors);
 * const FormText = getField(kea.Text);
 *
 * //FormText esta ligado su value, onChange y errors al de la forma
 * <FormText field="mi_campo" />
 */
export declare function formfields<T>(getProps: () => {
    value?: T;
    onChange?: (x: T) => void;
}, errors?: () => val.Result<T>): <TProps>(Component: React.ComponentClass<TProps> | ((props: TProps) => JSX.Element | null)) => React.ComponentClass<TProps & {
    field: keyof T;
}>;
