"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var moize_1 = require("moize");
var form_1 = require("./form");
/**Toma los props de un form y devuelve una función que convierte cualquier componente editor de un valor a uno que ya este ligado a un campo de ese form. Ejemplo
 * const getField =  formFieds(miValor, miOnChange, miErrors);
 * const FormText = getField(kea.Text);
 *
 * //FormText esta ligado su value, onChange y errors al de la forma
 * <FormText field="mi_campo" />
 */
function formfields(getProps, errors) {
    var onChange = form_1.handleFormChange(getProps);
    var func = function (Component) {
        var FieldComp = /** @class */ (function (_super) {
            __extends(FieldComp, _super);
            function FieldComp() {
                return _super !== null && _super.apply(this, arguments) || this;
            }
            FieldComp.prototype.render = function () {
                var errs = errors ? errors() : {};
                var value = getProps().value;
                var fieldProps = this.props;
                var mixedProps = __assign({ label: fieldProps.field, value: value && value[fieldProps.field], onChange: onChange(fieldProps.field), error: errs[fieldProps.field] }, fieldProps);
                var field = mixedProps.field, renderProps = __rest(mixedProps, ["field"]);
                return React.createElement(Component, __assign({}, renderProps));
            };
            return FieldComp;
        }(React.Component));
        var ret = FieldComp;
        var innerName = Component.displayName || Component.name || "Component";
        ret.displayName = "FormField(" + innerName + ")";
        return ret;
    };
    var ret = moize_1.default(func);
    return ret;
}
exports.formfields = formfields;
