"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var format_1 = require("./format");
var botones_1 = require("../botones");
var GridCellComponent = /** @class */ (function (_super) {
    __extends(GridCellComponent, _super);
    function GridCellComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    GridCellComponent.prototype.render = function () {
        var text = format_1.formatCellData(this.props.data, this.props.format);
        return (React.createElement("td", { title: text }, text));
    };
    return GridCellComponent;
}(React.PureComponent));
exports.GridCellComponent = GridCellComponent;
/**Controles de las cabeceras del grid */
var GridCellControls = /** @class */ (function (_super) {
    __extends(GridCellControls, _super);
    function GridCellControls() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    GridCellControls.prototype.render = function () {
        var props = this.props;
        return (React.createElement("span", null,
            props.orden &&
                React.createElement(botones_1.Link, { onClick: props.onOrdenar, style: "info", iconClass: "fa fa-sort-" + props.orden }),
            props.puedeFiltrar &&
                React.createElement(botones_1.Link, { style: props.estaFiltrado ? "info" : undefined, iconClass: "fa fa-filter", onClick: props.onFiltrar })));
    };
    return GridCellControls;
}(React.PureComponent));
exports.GridCellControls = GridCellControls;
var thStyle = { whiteSpace: "nowrap", cursor: "pointer" };
var GridHeaderComponent = /** @class */ (function (_super) {
    __extends(GridHeaderComponent, _super);
    function GridHeaderComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    GridHeaderComponent.prototype.render = function () {
        return (React.createElement("th", { style: thStyle },
            React.createElement("span", null,
                React.createElement("span", { onClick: this.props.puedeOrdenar ? this.props.onOrdenar : undefined }, this.props.titulo),
                React.createElement(GridCellControls, __assign({}, this.props)))));
    };
    return GridHeaderComponent;
}(React.PureComponent));
exports.GridHeaderComponent = GridHeaderComponent;
