"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var logic_1 = require("./logic");
var form_1 = require("../form");
var fields_1 = require("../fields/fields");
var selector_1 = require("../selector");
var botones_1 = require("../botones");
var format_1 = require("./format");
/**Obtiene un arreglo con los tipos de filtros adecuados segun la información, el arreglo tiene un elemento por cada celda */
function obtenerTiposFiltro(tiposColumnas) {
    var ret = tiposColumnas.map(function (x) { return (x == "string" ? "valorUnico" :
        x == "boolean" ? "valorUnico" :
            x == "null" ? null :
                x == "Date" ? "rangoFecha" :
                    x == "number" ? "rangoNumerico" : null); });
    return ret;
}
exports.obtenerTiposFiltro = obtenerTiposFiltro;
/**Agrega un nuevo filtro a un filtro columna, devuelve el nuevo arreglo de filtro columna */
function crearFiltro(tipoFiltro) {
    switch (tipoFiltro) {
        case "rangoFecha":
            return { kind: "rangoFecha" };
        case "rangoNumerico":
            return { kind: "rangoNumerico" };
        case "valorUnico":
            return { kind: "valorUnico", valores: [] };
        case "busqueda":
            return { kind: "busqueda", texto: "" };
    }
}
exports.crearFiltro = crearFiltro;
var FiltroRangoNumericoComponent = /** @class */ (function (_super) {
    __extends(FiltroRangoNumericoComponent, _super);
    function FiltroRangoNumericoComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleChange = form_1.handleFormChange(function () { return _this.props; });
        return _this;
    }
    FiltroRangoNumericoComponent.prototype.render = function () {
        var x = this.props.value;
        var change = this.handleChange;
        var titulo = this.props.columnas[this.props.columna].titulo;
        return (React.createElement("div", null,
            React.createElement("div", { className: "col-md-6" },
                React.createElement(fields_1.Number, { value: x.inicio, label: React.createElement("span", null,
                        React.createElement(botones_1.Link, { iconClass: "fa fa-times", onClick: this.props.onQuitar }),
                        " ",
                        React.createElement("label", null, titulo + " inicio")), onChange: change("inicio") })),
            React.createElement("div", { className: "col-md-6" },
                React.createElement(fields_1.Number, { value: x.final, label: titulo + " final", onChange: change("final") }))));
    };
    return FiltroRangoNumericoComponent;
}(React.PureComponent));
var FiltroRangoFechasComponent = /** @class */ (function (_super) {
    __extends(FiltroRangoFechasComponent, _super);
    function FiltroRangoFechasComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleChange = form_1.handleFormChange(function () { return _this.props; });
        return _this;
    }
    FiltroRangoFechasComponent.prototype.render = function () {
        var x = this.props.value;
        var change = this.handleChange;
        var titulo = this.props.columnas[this.props.columna].titulo;
        return (React.createElement("div", null,
            React.createElement("div", { className: "col-md-6" },
                React.createElement(fields_1.DateTime, { value: x.inicio, label: React.createElement("span", null,
                        React.createElement(botones_1.Link, { iconClass: "fa fa-times", onClick: this.props.onQuitar }),
                        " ",
                        React.createElement("label", null, titulo + " inicio")), onChange: change("inicio") })),
            React.createElement("div", { className: "col-md-6" },
                React.createElement(fields_1.DateTime, { value: x.final, label: titulo + " final", onChange: change("final") }))));
    };
    return FiltroRangoFechasComponent;
}(React.PureComponent));
var FiltroBusquedaTextoComponent = /** @class */ (function (_super) {
    __extends(FiltroBusquedaTextoComponent, _super);
    function FiltroBusquedaTextoComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleChange = function (value) {
            if (_this.props.onChange) {
                _this.props.onChange(__assign({}, _this.props.value, { texto: value }));
            }
        };
        return _this;
    }
    FiltroBusquedaTextoComponent.prototype.render = function () {
        var titulo = this.props.columnas[this.props.columna].titulo;
        var label = React.createElement("span", null,
            React.createElement(botones_1.Link, { iconClass: "fa fa-times", onClick: this.props.onQuitar }),
            " ",
            React.createElement("label", null, titulo));
        return (React.createElement("div", null,
            React.createElement(fields_1.Text, { value: this.props.value.texto, onChange: this.handleChange, label: label })));
    };
    return FiltroBusquedaTextoComponent;
}(React.PureComponent));
var FiltroInvalido = /** @class */ (function (_super) {
    __extends(FiltroInvalido, _super);
    function FiltroInvalido() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FiltroInvalido.prototype.render = function () {
        return React.createElement("a", { style: { color: "red", cursor: "pointer" }, onClick: this.props.onQuitar }, "Filtro inv\u00E1lido, click aqui para quitar el filtro");
    };
    return FiltroInvalido;
}(React.PureComponent));
var FiltroValorUnicoComponent = /** @class */ (function (_super) {
    __extends(FiltroValorUnicoComponent, _super);
    function FiltroValorUnicoComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleChange = form_1.handleFormChange(function () { return _this.props; });
        return _this;
    }
    FiltroValorUnicoComponent.prototype.unicos = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = logic_1.valoresUnicos;
                        return [4 /*yield*/, this.props.filas];
                    case 1: return [2 /*return*/, _a.apply(void 0, [_b.sent(), this.props.columna])];
                }
            });
        });
    };
    FiltroValorUnicoComponent.prototype.items = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.unicos()];
                    case 1: return [2 /*return*/, (_a.sent()).map(function (x) { return ({ value: x, label: format_1.formatCellData(x) }); })];
                }
            });
        });
    };
    FiltroValorUnicoComponent.prototype.render = function () {
        var x = this.props.value;
        var change = this.handleChange;
        var items = this.items();
        var titulo = this.props.columnas[this.props.columna].titulo;
        var label = React.createElement("span", null,
            React.createElement(botones_1.Link, { iconClass: "fa fa-times", onClick: this.props.onQuitar }),
            " ",
            React.createElement("label", null, titulo));
        return (React.createElement("div", null,
            React.createElement(selector_1.MultiSelect, { value: x.valores, onChange: change("valores"), items: items, label: label })));
    };
    return FiltroValorUnicoComponent;
}(React.PureComponent));
var FiltroComponent = /** @class */ (function (_super) {
    __extends(FiltroComponent, _super);
    function FiltroComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FiltroComponent.prototype.render = function () {
        //El filtro puede ser invalido cuando el usuario seleccione ciertos parametros del filtro, estos se guarden en el cache, y en
        //versiones posteriores esas columnas ya no existan en la información
        var filtroInvalido = this.props.columna >= this.props.columnas.length;
        var kind = this.props.value.kind;
        var tipo = filtroInvalido ? FiltroInvalido :
            kind == "rangoFecha" ? FiltroRangoFechasComponent :
                kind == "rangoNumerico" ? FiltroRangoNumericoComponent :
                    kind == "valorUnico" ? FiltroValorUnicoComponent :
                        kind == "busqueda" ? FiltroBusquedaTextoComponent :
                            null;
        var comp = React.createElement(tipo, __assign({}, this.props));
        return comp;
    };
    return FiltroComponent;
}(React.PureComponent));
var FiltroListComponent = /** @class */ (function (_super) {
    __extends(FiltroListComponent, _super);
    function FiltroListComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleOnChange = function (value, indice) {
            if (_this.props.onChange) {
                var nuevo = _this.props.value.map(function (x, i) { return i == indice ? __assign({}, x, { datos: value }) : x; });
                _this.props.onChange(nuevo);
            }
        };
        _this.handleQuitar = function (indice) {
            if (_this.props.onChange) {
                _this.props.onChange(_this.props.value.filter(function (x, i) { return i != indice; }));
            }
        };
        return _this;
    }
    FiltroListComponent.prototype.render = function () {
        var _this = this;
        return (this.props.value.length > 0 ?
            React.createElement("div", null,
                React.createElement("div", { className: "row" }, this.props.value.map(function (x, i) {
                    return React.createElement("div", { className: "col-md-4" },
                        React.createElement(FiltroComponent, { filas: _this.props.filas, columnas: _this.props.columnas, columna: x.indice, value: x.datos, onChange: function (valor) { return _this.handleOnChange(valor, i); }, onQuitar: function () { return _this.handleQuitar(i); } }));
                }))) : null);
    };
    return FiltroListComponent;
}(React.PureComponent));
exports.FiltroListComponent = FiltroListComponent;
