/// <reference types="react" />
import React = require("react");
import { GridRow, OrdenGrid, GridColumn, FiltroColumna } from "./tipos";
import { PaginatedTableState } from "../table";
export interface GridState {
    orden?: OrdenGrid;
    filtros: FiltroColumna[];
    busqueda: string;
    pagination?: PaginatedTableState;
}
export interface GridProps {
    /**Definición de las columans del grid */
    columns: PromiseLike<GridColumn[]> | GridColumn[];
    /**Datos del grid */
    rows: PromiseLike<GridRow[]> | GridRow[];
    /**Objeto que se va a pasar a los metodos de generación de la fila visual de los rows. Utilice este objeto para cambiar la apariencia de las filas
     * sin necesidad de recalcular los filtros, paginación u ordenamientos del grid
     */
    visualProps?: any;
    /**Valores del filtro y del orden.*/
    gridState?: GridState;
    /**Se llama al modificar el filtro orden.*/
    onGridStateChange?: (value: GridState) => void;
    /**True para ocultar el cuadro de búsqueda */
    hideBusqueda?: boolean;
}
export declare class GridControlled extends React.PureComponent<GridProps> {
    render(): JSX.Element;
}
export declare const Grid: React.ComponentClass<GridProps & {
    cookieKey?: string | undefined;
}>;
