"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var logic_1 = require("./logic");
var pagination_1 = require("../pagination");
var filtros_1 = require("./filtros");
var async_1 = require("../async");
var text_1 = require("../fields/text");
var botones_1 = require("../botones");
var downloadjs_1 = require("../downloadjs");
var files_1 = require("../files");
var csv_1 = require("./csv");
var memoize = require("memoizeref");
var HOC_1 = require("../HOC");
/**Obtiene la cabecera de un grid */
function getTableHeader(columns) {
    var cells = columns.map(function (x) { return x.header; });
    return (React.createElement("tr", null, cells));
}
/**
 * El grid es un control similar a la tabla paginada, pero que toma los datos en lugar de las filas de la tabla, es un
 * control menos flexible pero que ofrece posibilidad de ordenar los datos por columna, filtrar los datos de manera dinámina
 * y de exportar a excel o CSV ya que tiene acceso a los datos sin procesar
 */
var SyncGrid = /** @class */ (function (_super) {
    __extends(SyncGrid, _super);
    function SyncGrid() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * Alterna el ordenamiento de la columna especificada
         */
        _this.handleOnOrdenar = function (index) {
            var orden = _this.gridState.orden;
            if (!orden || orden.columna != index) {
                _this.setFiltroOrden({ orden: { columna: index, orden: "asc" } });
            }
            else {
                _this.setFiltroOrden({ orden: orden.orden == "asc" ? { columna: index, orden: "desc" } : undefined });
            }
        };
        /**
         * Agrega o quita el filtro de cierta columna
         */
        _this.handleOnFiltrar = function (index, tipoFiltro) {
            var estaFiltrado = _this.gridState.filtros.map(function (x) { return x.indice; }).indexOf(index) != -1;
            var nuevoFiltro = {
                datos: filtros_1.crearFiltro(tipoFiltro),
                indice: index
            };
            var nuevoArr = estaFiltrado ?
                _this.gridState.filtros.filter(function (x) { return x.indice != index; }) : //Quitar el filtro
             __spread(_this.gridState.filtros, [nuevoFiltro]); //Poner el filtro
            _this.setFiltroOrden({ filtros: nuevoArr });
        };
        _this.handlePaginationChange = function (value) {
            _this.setFiltroOrden({ pagination: value });
        };
        /**
         * Descarga la información que esta viendo el usuario en un CSV
         */
        _this.handleDownload = function () { return __awaiter(_this, void 0, void 0, function () {
            var dataFiltered, _a, data, csv, blob;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.filtrarOrdenar;
                        return [4 /*yield*/, this.props.rows];
                    case 1:
                        dataFiltered = _a.apply(this, [_b.sent(), this.gridState.orden, this.gridState.filtros, this.gridState.busqueda, this.props.columns.length]);
                        data = logic_1.ObtenerDatosCsv(dataFiltered.map(function (x) { return logic_1.toGridRowExEx(x); }), this.props.columns.map(function (x) { return logic_1.toGridColumnEx(x); }));
                        csv = csv_1.toCSV(data);
                        blob = files_1.stringToBlob(csv);
                        downloadjs_1.download(blob, "Lista.csv");
                        return [2 /*return*/];
                }
            });
        }); };
        _this.filtrarOrdenar = memoize(logic_1.filtrarOrdenar);
        _this.getHeader = memoize(logic_1.getGridHeader);
        _this.obtenerTiposColumnas = memoize(logic_1.obtenerTiposColumnas);
        _this.obtenerTiposFiltro = memoize(filtros_1.obtenerTiposFiltro);
        _this.obtenerColumnasNormalizadas = memoize(function (cols) { return cols.map(function (x) { return logic_1.toGridColumnEx(x); }); });
        return _this;
    }
    Object.defineProperty(SyncGrid.prototype, "gridState", {
        get: function () {
            return this.props.gridState || { filtros: [], busqueda: "" };
        },
        enumerable: true,
        configurable: true
    });
    SyncGrid.prototype.setFiltroOrden = function (value) {
        if (this.props.gridStateChange) {
            var newValue = __assign({}, this.gridState, value);
            this.props.gridStateChange(newValue);
        }
    };
    SyncGrid.prototype.getDataFiltered = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.filtrarOrdenar;
                        return [4 /*yield*/, this.props.rows];
                    case 1: return [2 /*return*/, _a.apply(this, [_b.sent(), this.gridState.orden, this.gridState.filtros, this.gridState.busqueda, this.props.columns.length])];
                }
            });
        });
    };
    SyncGrid.prototype.getRows = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var data, rows;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getDataFiltered()];
                    case 1:
                        data = (_a.sent());
                        rows = data.map(function (row, i) { return logic_1.getGridRow(row, i, function () { return _this.props.visualProps; }); });
                        return [2 /*return*/, rows];
                }
            });
        });
    };
    SyncGrid.prototype.getTiposFiltros = function () {
        return __awaiter(this, void 0, void 0, function () {
            var tipos, _a, filtros;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.obtenerTiposColumnas;
                        return [4 /*yield*/, this.props.rows];
                    case 1:
                        tipos = _a.apply(this, [_b.sent(), this.props.columns.length]);
                        filtros = this.obtenerTiposFiltro(tipos);
                        return [2 /*return*/, filtros];
                }
            });
        });
    };
    SyncGrid.prototype.getGridHeader = function (columnas) {
        var _this = this;
        var filtrosProm = this.getTiposFiltros();
        var sinFiltros = columnas.map(function (x) { return null; });
        return async_1.async(filtrosProm, function (filtros) { return _this.getHeader(columnas, _this.gridState.orden, filtros, _this.gridState.filtros, _this.handleOnOrdenar, _this.handleOnFiltrar); }, { cargando: this.getHeader(columnas, this.gridState.orden, sinFiltros, this.gridState.filtros, this.handleOnOrdenar, this.handleOnFiltrar) });
    };
    SyncGrid.prototype.render = function () {
        var _this = this;
        var orden = this.gridState.orden;
        var dataFiltered = this.getDataFiltered();
        var filtros = this.getTiposFiltros();
        var columnas = this.obtenerColumnasNormalizadas(this.props.columns);
        var header = this.getGridHeader(columnas);
        var rows = this.getRows();
        return (React.createElement("div", null,
            React.createElement(filtros_1.FiltroListComponent, { filas: this.props.rows, columnas: columnas, onChange: function (x) { return _this.setFiltroOrden({ filtros: x }); }, value: this.gridState.filtros }),
            !this.props.hideBusqueda &&
                React.createElement("div", { style: { display: "flex", flexDirection: "row" } },
                    React.createElement("div", { style: { flex: "1 1 auto" } },
                        React.createElement(text_1.Text, { value: this.gridState.busqueda, placeholder: "Búsqueda", onChange: function (x) { return _this.setFiltroOrden({ busqueda: x }); }, addon: React.createElement("i", { className: "fa fa-search" }) })),
                    React.createElement("div", { style: { flex: "0 1 auto" } },
                        React.createElement(botones_1.Button, { tooltip: "Descargar CSV", style: "success", iconClass: "fa fa-download", onClick: this.handleDownload }))),
            React.createElement(pagination_1.PaginatedTable, { header: header, items: rows, value: this.gridState.pagination, onChange: this.handlePaginationChange })));
    };
    return SyncGrid;
}(React.PureComponent));
var GridControlled = /** @class */ (function (_super) {
    __extends(GridControlled, _super);
    function GridControlled() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    GridControlled.prototype.render = function () {
        var _this = this;
        return async_1.async(Promise.all([this.props.columns]), function (all) {
            return React.createElement(SyncGrid, { columns: all[0], rows: _this.props.rows, visualProps: _this.props.visualProps, gridState: _this.props.gridState, gridStateChange: _this.props.onGridStateChange, hideBusqueda: _this.props.hideBusqueda });
        });
    };
    return GridControlled;
}(React.PureComponent));
exports.GridControlled = GridControlled;
//Habilitamos el uso descontrolado de filtroOrden:
exports.Grid = HOC_1.MakeUncontrolledCookies("gridState", "onGridStateChange")(GridControlled);
