"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var text_1 = require("../simpleGrid/text");
var objectcell_1 = require("./cells/objectcell");
var arraycell_1 = require("./cells/arraycell");
/**Vista por default para una celda */
exports.defaultCellView = function (data, sharedData, onDrillDown, string) {
    if (isSimpleCellData(data)) {
        return string == undefined ? text_1.cellToText(data) : string;
    }
    else {
        return exports.objectCell(data, sharedData, onDrillDown, string);
    }
};
/**Vista para un objeto con capacitdad de hacer un drill down */
exports.objectCell = function (data, sharedData, onDrillDown) {
    return React.createElement(objectcell_1.ObjectCell, { value: data, onDrillDown: onDrillDown });
};
/**Función que devuelve un view dadas las dependencias de un array cell */
exports.arrayCell = function (deps) { return function (data, sharedData, onDrillDown, string) {
    return React.createElement(arraycell_1.ArrayCell, __assign({}, (deps || {}), { value: data, string: string }));
}; };
function isSimpleCellData(x) {
    if (typeof (x) == "object" && x != null && !(x instanceof Date)) {
        return false;
    }
    //Comprobacion del compilador:
    var y = x;
    return true;
}
