/// <reference types="react" />
import React = require("react");
import { Grid2Column } from "../simpleGrid/column";
import { FiltroColumnaMap } from "../simpleGrid/gridState";
import { FiltroComponent, ItemRowData } from "../simpleGrid/tiposFiltros";
export declare type Items<TItem> = PromiseLike<TItem[]> | TItem[];
export interface FiltroListProps<TItem, TShared> {
    value: FiltroColumnaMap;
    onChange: (value: FiltroColumnaMap) => void;
    columnas: FiltroComponentColumnaMap;
    items: PromiseLike<ItemRowData<TItem>[]>;
}
export interface FiltroComponentColumna<TItem> {
    /**Titulo de la columna*/
    title: string;
    key: string | number;
    /**Filtro que se va a usar en esta columna*/
    filterComponent: PromiseLike<FiltroComponent<any>>;
}
export interface FiltroComponentColumnaMap {
    [k: string]: FiltroComponentColumna<any>;
}
/**Convierte un GridColumn a un FiltroComponentColumna */
export declare function gridColumnToFiltroColumn<TItem>(data: TItem[] | PromiseLike<TItem[]>, value: Grid2Column<TItem, any>): FiltroComponentColumna<TItem>;
/**Componente que muestra todos los filtros de un grid */
export declare class FiltroListComponent extends React.PureComponent<FiltroListProps<any, any>> {
    private handleOnChange;
    private handleQuitar;
    render(): JSX.Element;
}
