/// <reference types="react" />
import React = require("react");
import { Grid2Column } from "../simpleGrid/column";
import { Grid2State } from "../simpleGrid/gridState";
export declare type Items<T> = T[] | PromiseLike<T[]>;
import { Observable } from "rxjs";
export interface Grid2Props<TItem, TShared> {
    columnas: Grid2Column<TItem, TShared>[];
    items?: Items<TItem>;
    getKey?: (item: TItem) => string | number;
    gridState?: Partial<Grid2State>;
    onGridStateChange?: (value: Grid2State) => void;
    /**True para ocultar el cuadro de búsqueda */
    hideBusqueda?: boolean;
    sharedProps?: TShared;
    onDescargarCsv?: () => void;
}
export declare type Props = Grid2Props<any, any>;
export declare const Grid2: React.ComponentClass<{
    columnas: Grid2Column<any, any>[] | Observable<Grid2Column<any, any>[]>;
    items?: any[] | PromiseLike<any[]> | Observable<any[] | PromiseLike<any[]> | undefined> | undefined;
    getKey?: ((item: any) => string | number) | Observable<((item: any) => string | number) | undefined> | undefined;
    gridState?: Partial<Grid2State> | Observable<Partial<Grid2State> | undefined> | undefined;
    onGridStateChange?: ((value: Grid2State) => void) | Observable<((value: Grid2State) => void) | undefined> | undefined;
    hideBusqueda?: boolean | Observable<boolean | undefined> | undefined;
    sharedProps?: any;
    onDescargarCsv?: (() => void) | Observable<(() => void) | undefined> | undefined;
    cookieKey?: string | Observable<string | undefined> | undefined;
}>;
