/// <reference types="react" />
import React = require("react");
import { Grid2Column } from "../simpleGrid/column";
import { Grid2State } from "../simpleGrid/gridState";
import { ItemRowData } from "../simpleGrid/tiposFiltros";
export interface DummyTableProps {
    header: JSX.Element;
    value: Grid2State;
}
export interface AsyncPaginatedTableProps<TItem, TShared> {
    header: JSX.Element;
    /**Los elementos ya filtrados y ordenados pero sin paginar */
    items: PromiseLike<ItemRowData<TItem>[]>;
    getKey?: (item: TItem) => string | number;
    sharedData?: TShared;
    columns: Grid2Column<TItem, TShared>[];
    /**Valor de la paginación */
    value: Grid2State;
    onChange: (value: Grid2State) => void;
}
export declare class AsyncGridTable extends React.PureComponent<AsyncPaginatedTableProps<any, any>> {
    render(): JSX.Element;
}
