"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var keautils_1 = require("keautils");
var filtrarOrdenar_1 = require("./filtrarOrdenar");
var csv_1 = require("../../grid/csv");
var files_1 = require("../../files");
var downloadjs_1 = require("../../downloadjs");
var text_1 = require("./text");
/**Genera las filas de un CSV */
function generateCsvRows(rows, state, columns) {
    return __awaiter(this, void 0, void 0, function () {
        var filtroColumns, rowsSync, itemsFiltro, _a, _b, filteredData, _c, _d, exportMap, mappedColumns, toCsvCell, toCsvRow, csv, header;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    filtroColumns = keautils_1.promiseAllObj(keautils_1.mapObject(columns, function (value) { return filtrarOrdenar_1.gridColumnToFiltroOrdenColumn(rows, value); }));
                    return [4 /*yield*/, rows];
                case 1:
                    rowsSync = _e.sent();
                    _a = filtrarOrdenar_1.getItemCellData;
                    _b = [rowsSync];
                    return [4 /*yield*/, filtroColumns];
                case 2:
                    itemsFiltro = _a.apply(void 0, _b.concat([_e.sent()]));
                    _c = filtrarOrdenar_1.filtrarOrdenar;
                    _d = [itemsFiltro, state.filtroOrden];
                    return [4 /*yield*/, filtroColumns];
                case 3:
                    filteredData = _c.apply(void 0, _d.concat([_e.sent()])).map(function (x) { return x.original; });
                    exportMap = state.export;
                    mappedColumns = exportMap.map(function (key) { return columns[key]; });
                    toCsvCell = function (cell) { return cell.string == undefined ? text_1.cellToText(cell.data) : cell.string; };
                    toCsvRow = function (row) { return mappedColumns.map(function (col) { return toCsvCell(col.cell(row)); }); };
                    csv = filteredData.map(toCsvRow);
                    header = mappedColumns.map(function (x) { return x.title; });
                    return [2 /*return*/, __spread([header], csv)];
            }
        });
    });
}
exports.generateCsvRows = generateCsvRows;
/**Descarga el CSV del grid */
function downloadCsv(rows, state, columns) {
    return __awaiter(this, void 0, void 0, function () {
        var data, str, blob;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, generateCsvRows(rows, state, columns)];
                case 1:
                    data = _a.sent();
                    str = csv_1.toCSV(data);
                    blob = files_1.stringToBlob(str);
                    downloadjs_1.download(blob, "Lista.csv");
                    return [2 /*return*/];
            }
        });
    });
}
exports.downloadCsv = downloadCsv;
