import { ColumnMap } from "./column";
import { Grid2State, DrillDownMap } from "./gridState";
import { Key } from "./baseTypes";
/**Obtiene la cantidad de columnas originales */
export declare function getOriginalColumnCount(totalColumns: number, drillDownCount: number): number;
/**Obtiene todas las columnas efectivas del grid, que son las originales concatenadas con las de drill down*/
export declare function getEffectiveColumns<TItem, TShared>(originalColumns: ColumnMap, drillDowns: DrillDownMap): ColumnMap;
/**Devuelve el nuevo state de un grid despues de una operación de quitar columna */
export declare function quitarColumna(key: Key, oldValue: Grid2State): Grid2State;
/**Devuelve el nuevo state despues de agregar un drilldown
 * @param column indice de la columna original
 * @param path ruta del drilldown
 */
export declare function addDrilldown(column: Key, path: (string | number)[], oldValue: Grid2State): Grid2State;
