"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var text_1 = require("./text");
var search_1 = require("../../search");
var keautils_1 = require("keautils");
var autoFiltro_1 = require("../filtros/autoFiltro");
var filtroInvalido_1 = require("../components/filtroInvalido");
/**Representa una fila del grid, despues de haber obtenido los valores con el getData */
/**Obtiene el filtro efectivo de la columna, si el filtro no esta definido en la columna se usa el selector getAutoFiltro */
function getFiltro(data, getData, filter) {
    return __awaiter(this, void 0, void 0, function () {
        var x, dataSync, defaultFilter, filtro;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    x = function () { return React.createElement("span", null); };
                    if (!filter) return [3 /*break*/, 1];
                    return [2 /*return*/, filter];
                case 1: return [4 /*yield*/, data];
                case 2:
                    dataSync = _a.sent();
                    defaultFilter = {
                        component: filtroInvalido_1.FiltroInvalidoComp,
                        filter: function () { return true; }
                    };
                    filtro = autoFiltro_1.getAutoFiltro(dataSync, getData) || defaultFilter;
                    return [2 /*return*/, filtro];
            }
        });
    });
}
exports.getFiltro = getFiltro;
/**
 * Para una lista de elementos, obtiene la misma lista de elementos pero obtieniendo cada uno de los datos de las columnas con sus respectivos getCell y los datos de la busqueda,
 * esta estructura de datos se usa para acelerar las búsquedas ya que estos valores se tendran que calcular sólo cuando cambien los items, en lugar de cada vez que se realize una búsqueda
 * @param data
 */
function getItemCellData(data, columnas) {
    console.log("Get items cell data");
    var ret = data.map(function (x) {
        var cell = keautils_1.mapObject(columnas, function (value, key) {
            var cell = value.cell(x);
            var string = cell.string;
            return {
                data: cell.data,
                string: string || text_1.cellToText(cell.data),
                style: cell.style,
                view: cell.view
            };
        });
        var textSearch = keautils_1.enumObject(cell).map(function (x) { return x.value.string; }).join(" ");
        return {
            cell: cell,
            original: x,
            textSearch: textSearch
        };
    });
    return ret;
}
exports.getItemCellData = getItemCellData;
/**Aplica los filtros de columnas y el orden a los datos
 * @param searchFunc Función que se utiliza en la búsqueda por texto
*/
function filtrarOrdenar(data, filtroOrden, columnas) {
    console.log("filtrar ordenar");
    var ret = data;
    ret = filtroBusqueda(ret, filtroOrden.busqueda);
    ret = filtrarPorColumnas(ret, filtroOrden.columna, columnas);
    if (filtroOrden.orden) {
        ret = ordenar(ret, filtroOrden.orden.orden, filtroOrden.orden.columna);
    }
    return ret;
}
exports.filtrarOrdenar = filtrarOrdenar;
/**Convierte una columna del grid a una columna FiltroOrdenColumna */
function gridColumnToFiltroOrdenColumn(data, value) {
    return __awaiter(this, void 0, void 0, function () {
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _a = {
                        cell: value.cell
                    };
                    return [4 /*yield*/, getFiltro(data, function (x) { return value.cell(x).data; }, value.filter)];
                case 1: return [2 /*return*/, (_a.filtro = (_b.sent()).filter,
                        _a)];
            }
        });
    });
}
exports.gridColumnToFiltroOrdenColumn = gridColumnToFiltroOrdenColumn;
function compare(a, b) {
    return (a == b ? 0 :
        a == null ? 1 :
            b == null ? -1 :
                a > b ? 1 :
                    a < b ? -1 : 0);
}
exports.compare = compare;
/**Ordena un conjunto de datos de un grid */
function ordenar(data, orden, column) {
    var getData = function (x) { return x.cell[column].data; };
    var sortFunc = function (a, b) { return (compare(a, b)) * (orden == "asc" ? 1 : -1); };
    var rowSortFunc = function (a, b) { return sortFunc(getData(a), getData(b)); };
    return __spread(data).sort(rowSortFunc);
}
/**Aplica los filtros por columna */
function filtrarPorColumnas(data, filtros, columnas) {
    //Función que aplica un filtro:
    var aplicarFiltro = function (filtro, data) {
        var columna = columnas[filtro.key];
        var pasaFiltro = function (x) {
            var cell = x.cell[filtro.key];
            var data = cell.data;
            var string = cell.string;
            return columna.filtro(data, filtro.datos || {}, string);
        };
        return data.filter(pasaFiltro);
    };
    /**Aplicamos todos los filtros: */
    var ret = keautils_1.enumObject(filtros, function (key, value) { return (__assign({}, value, { key: key })); }).reduce(function (datos, filtro) { return aplicarFiltro(filtro, datos); }, data);
    return ret;
}
/**Aplica el filtro de la búsqueda por texto */
function filtroBusqueda(items, busqueda) {
    if (!busqueda)
        return items;
    return items.filter(function (x) { return search_1.search(busqueda, x.textSearch); });
}
