"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
/**Mezcla una definición de una columna con una función de estilo, dandole prioridad al estilo original de las columnas */
function mixStyle(columm, style) {
    return __assign({}, columm, { cell: function (row) {
            var ret = columm.cell(row);
            var retStyleFunc = ret.style || (function () { return ({}); });
            return __assign({}, ret, { style: function (itemData) { return (__assign({}, style(row, itemData), retStyleFunc(itemData))); } });
        } });
}
/**Le agrega un estilo a todas las celdas de un arreglo de Grid2Column. Si la celda ya define su propio estilo, este es mezclado con el estido dado por la funcion
 * rowStyle con el operador spread (...), dandole prioridad a las propiedades del estilo definido por la celda
 */
function applyRowStyleToColumns(columns, rowStyle) {
    return columns.map(function (col) { return mixStyle(col, rowStyle); });
}
exports.applyRowStyleToColumns = applyRowStyleToColumns;
