"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var keautils_1 = require("keautils");
function filtrarFiltroOrden(x, columnKeys) {
    return __assign({}, x, { columna: keautils_1.filterObject(x.columna, function (x, key) { return keautils_1.contains(columnKeys, key); }), orden: x.orden && (keautils_1.contains(columnKeys, x.orden.columna) ? x.orden : undefined) });
}
function filtrarDrillDowns(x, columnKeys) {
    return keautils_1.filterObject(x, function (x, key) { return keautils_1.contains(columnKeys, x.columna); });
}
function filterMapping(x, columnkeys) {
    return keautils_1.intersect(x, columnkeys);
}
/**Obtiene los valores por default del grid state y filtra los nombres de las columnas que no existe, esto es por que como el grid state generalmente se almacena en los cookies, puede ser
 * que nuevas versiones del sistema ya no tengan columnas que esten referenciadas en el mismo
 */
function gridStateDefaultValues(value, originalColumnKeys) {
    value = value || {};
    return {
        filtroOrden: value.filtroOrden ? filtrarFiltroOrden(value.filtroOrden, originalColumnKeys) : { busqueda: "", columna: {}, orden: undefined },
        drillDowns: value.drillDowns ? filtrarDrillDowns(value.drillDowns, originalColumnKeys) : {},
        paginacion: value.paginacion || { selectedPage: 0, selectedPageSize: 15 },
        mapping: value.mapping ? filterMapping(value.mapping, originalColumnKeys) : originalColumnKeys,
        export: value.export ? filterMapping(value.export, originalColumnKeys) : originalColumnKeys
    };
}
exports.gridStateDefaultValues = gridStateDefaultValues;
