import { Grid2Column } from "./column";
import { BootstrapButtonStyle } from "../../botones";
export interface BotonesListaDeps<T> {
    onEdit: (x: T) => void;
    onBorrar: (x: T) => void;
}
/**
 * Dadas las funciones de editar y borrar devuelve un conjunto de botones de grid con los botones de editar y borrar
 * @param deps
 */
export declare function columnaBotonesDefault<T>(deps: BotonesListaDeps<T>): BotonGrid<T>[];
/**Una definición de un botón para un grid */
export interface BotonGrid<T> {
    onClick: (item: T) => void;
    tooltip?: string;
    iconClass?: string;
    disabled?: boolean;
    style?: BootstrapButtonStyle;
}
/**Crea una columna para el grid formada por un conjunto de botones */
export declare function columnaBotones<T>(botones: (BotonGrid<T> | false)[]): Grid2Column<T>;
