"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var botones_1 = require("../../botones");
var React = require("react");
/**
 * Dadas las funciones de editar y borrar devuelve un conjunto de botones de grid con los botones de editar y borrar
 * @param deps
 */
function columnaBotonesDefault(deps) {
    return [
        { iconClass: "fa fa-pencil", style: "info", tooltip: "Editar", onClick: deps.onEdit },
        { iconClass: "fa fa-trash-o", style: "danger", tooltip: "Eliminar", onClick: deps.onBorrar },
    ];
}
exports.columnaBotonesDefault = columnaBotonesDefault;
/**Crea una columna para el grid formada por un conjunto de botones */
function columnaBotones(botones) {
    var filtrados = botones.filter(function (x) { return x !== false; }).map(function (x) { return x; });
    var componentes = function (x) {
        return filtrados.map(function (bot, i) {
            return React.createElement(botones_1.Link, { key: i, iconClass: bot.iconClass || "fa fa-cicle", disabled: bot.disabled, onClick: function () { return bot.onClick(x); }, tooltip: bot.tooltip, style: bot.style });
        });
    };
    return {
        title: "",
        key: "_botones",
        cell: function (x) { return ({
            data: undefined,
            view: function () {
                return React.createElement("span", null, componentes(x));
            }
        }); }
    };
}
exports.columnaBotones = columnaBotones;
