/// <reference types="react" />
import React = require('react');
export interface HeaderProps {
    /**Titulo del header*/
    titulo: string;
    cargando?: boolean;
    /**Acción que se va a ejecutar cuando den click en regresar, si no se especifica por default viaja hacia atrás
     * en el historial de navegación
     */
    onRegresar?: () => void | Promise<void>;
}
/**
 * Una cabecera para un container. Para poner botones en la cabecera asignelos a los hijos de este elemento. Ya incluye un botón regresar a la derecha de todos los botones
 */
export declare class Header extends React.PureComponent<HeaderProps, {}> {
    render(): JSX.Element;
}
export interface EditHeaderProps {
    /**True si se esta editando, falso si se esta creando una nueva entidad */
    editando: boolean;
    /**Tipo de la entidad que se utilizará en el titulo */
    entityType: string;
    /**True si se esta cargando la pagina */
    cargando?: boolean;
}
/**Cabecera de una vista de edicion de una entidad. El elemento devuelto es un <div class="row" /> asi que se puede
 * usar directamente adentro de un "container"
 */
export declare class EditHeader extends React.PureComponent<EditHeaderProps, {}> {
    render(): JSX.Element;
}
export interface ListHeaderProps {
    title: string;
    onAgregar?: () => void;
}
/**Cabecera de una lista. Muestra el botón de agregary el botón de regresar */
export declare class ListHeader extends React.PureComponent<ListHeaderProps, {}> {
    render(): JSX.Element;
}
