"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var botones = require("./botones");
var cargando = require("./cargando");
/**
 * Una cabecera para un container. Para poner botones en la cabecera asignelos a los hijos de este elemento. Ya incluye un botón regresar a la derecha de todos los botones
 */
var Header = /** @class */ (function (_super) {
    __extends(Header, _super);
    function Header() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Header.prototype.render = function () {
        return (React.createElement("div", { className: "row" },
            React.createElement("div", { className: "col-md-12" },
                React.createElement("h3", null,
                    React.createElement("span", null,
                        this.props.titulo,
                        this.props.cargando && React.createElement(cargando.Spinner, null)),
                    React.createElement("div", { className: "pull-right" },
                        this.props.children,
                        this.props.onRegresar &&
                            React.createElement(botones.RegresarButton, { onClick: this.props.onRegresar }))),
                React.createElement("hr", null))));
    };
    return Header;
}(React.PureComponent));
exports.Header = Header;
/**Cabecera de una vista de edicion de una entidad. El elemento devuelto es un <div class="row" /> asi que se puede
 * usar directamente adentro de un "container"
 */
var EditHeader = /** @class */ (function (_super) {
    __extends(EditHeader, _super);
    function EditHeader() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    EditHeader.prototype.render = function () {
        return (React.createElement(Header, { titulo: (this.props.editando ? 'Editar ' : 'Crear ') + this.props.entityType + ' ' }));
    };
    return EditHeader;
}(React.PureComponent));
exports.EditHeader = EditHeader;
/**Cabecera de una lista. Muestra el botón de agregary el botón de regresar */
var ListHeader = /** @class */ (function (_super) {
    __extends(ListHeader, _super);
    function ListHeader() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ListHeader.prototype.render = function () {
        return (React.createElement(Header, { titulo: this.props.title },
            React.createElement(botones.AgregarButton, { onClick: this.props.onAgregar })));
    };
    return ListHeader;
}(React.PureComponent));
exports.ListHeader = ListHeader;
