/// <reference types="react" />
import { GridRow, GridColumn } from "../grid/tipos";
import { GridState } from "../grid/grid";
import React = require("react");
import { SelectorValue } from "../selector";
export interface GridSelectorElement {
    id: SelectorValue;
    row: GridRow;
}
export interface MultiSelectGridProps {
    /**Elementos del selector */
    items: PromiseLike<GridSelectorElement[]> | GridSelectorElement[];
    /**Columnas del grid */
    columns: PromiseLike<GridColumn[]> | GridColumn[];
    value: PromiseLike<SelectorValue[]> | SelectorValue[];
    onChange?: (value: SelectorValue[]) => void;
    /**Valores del filtro y del orden.*/
    gridState?: GridState;
    /**Se llama al modificar el filtro orden.*/
    onGridStateChange?: (value: GridState) => void;
    /**Nombre del cookie que se usara para almacenar el gridState en caso de que se quiera recordar */
    cookieKey?: string;
}
export declare const MultiSelectGrid: React.ComponentClass<MultiSelectGridProps & {
    cookieKey?: string | undefined;
}>;
