/// <reference types="react" />
import React = require("react");
import table = require("./table");
/**Propiedades del paginador */
export interface PageSelectorProps {
    /**Cantidad de paginas */
    count: number;
    /**Pagina seleccionada, iniciando en 0 */
    selected?: number;
    /**Se ejecuta cuando el usuario de la click a una pagina, el numero de pagina inicia en 0 */
    onValueChanged?: (page: number) => void;
}
/**Un selector de pagina */
export declare class PageSelector extends React.PureComponent<PageSelectorProps, {}> {
    readonly Items: {
        value: number;
        label: number;
        tooltip: string;
    }[];
    handleOnChange: (value: any) => void;
    render(): JSX.Element;
}
export declare const PaginatedTable: React.ComponentClass<table.AsyncPaginatedTableProps & {
    cookieKey?: string | undefined;
}>;
