"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var cargando = require("./cargando");
var promiseEx = require("./promiseEx");
function verifyFunction(func) {
    if (func == null || typeof func != "function")
        throw "El argumento 'map' debe de ser una función";
}
/**Convierte una función que mapea un modelo a un componente de react a otra que mapea el modelo a un componente
 * de cargando que muestra el error y el spinner de cargando. La función que devuelve es compatibla con la función que espera
 * el componente Query
 */
function CargandoModelMap(map) {
    verifyFunction(map);
    return function (_cargando, error, model, onModelChanged, requestQuery) {
        return React.createElement(cargando.Cargando, { Error: error, Cargando: _cargando }, !error && !_cargando && map(model, onModelChanged, requestQuery));
    };
}
exports.CargandoModelMap = CargandoModelMap;
/**Convierte una función que mapea un modelo a un componente de react a otra que mapea el modelo a un
 * componente de cargando con su respectivos elementos constantes de cargando y una función para crear el componente de error
  */
function ConstantModelMap(map, cargandoComponent, errorFunc) {
    verifyFunction(map);
    return function (_cargando, error, model, onModelChanged, requestQuery) {
        return error ? errorFunc(error) :
            _cargando ? cargandoComponent : map(model, onModelChanged, requestQuery);
    };
}
exports.ConstantModelMap = ConstantModelMap;
/**Componente que muestra un componente en función al resultado de un query asíncrono que esta
 * en función de ciertos parametros
 * debera de heredar del componente para establecer los tipos genericos.
 *
 * Cuando cambien los parametros del query automaticamente vuelve a llamar al query
 */
var Query = /** @class */ (function (_super) {
    __extends(Query, _super);
    function Query(props) {
        var _this = _super.call(this, props) || this;
        /**Refresca el query */
        _this.refreshFull = function () { return __awaiter(_this, void 0, void 0, function () {
            var result, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.setState({ Cargando: true, Error: null });
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 4, , 5]);
                        //Delay para forzar la actualización del estado anterior
                        return [4 /*yield*/, promiseEx.Delay(1000)];
                    case 2:
                        //Delay para forzar la actualización del estado anterior
                        _a.sent();
                        return [4 /*yield*/, this.props.query(this.props.queryParams)];
                    case 3:
                        result = _a.sent();
                        this.setState({
                            Model: result,
                            Cargando: false,
                            Error: null
                        });
                        return [3 /*break*/, 5];
                    case 4:
                        err_1 = _a.sent();
                        console.error("Query error: " + err_1);
                        this.setState({
                            Model: null,
                            Cargando: false,
                            Error: err_1
                        });
                        return [3 /*break*/, 5];
                    case 5: return [2 /*return*/];
                }
            });
        }); };
        _this.handleOnModelChanged = function (newValue) {
            _this.setState({ Model: newValue });
        };
        console.warn("El componente kea.Query esta obsoleto, utilice kea.Async");
        //Initial state:
        _this.state = {
            Cargando: !props.preventInitialRequest
        };
        return _this;
    }
    Query.prototype.componentDidMount = function () {
        if (!this.props.preventInitialRequest)
            this.refreshFull();
    };
    Query.prototype.componentWillReceiveProps = function (nextProps) {
        //Si cambiaron los parametros del query, refrescamos
        if (JSON.stringify(this.props.queryParams) != JSON.stringify(nextProps.queryParams)) {
            this.refreshFull();
        }
    };
    Query.prototype.render = function () {
        return this.props.map(this.state.Cargando || false, this.state.Error, this.state.Model, this.handleOnModelChanged, this.refreshFull);
    };
    return Query;
}(React.Component));
exports.Query = Query;
/**Query tipado con any */
var ConcreteQuery = /** @class */ (function (_super) {
    __extends(ConcreteQuery, _super);
    function ConcreteQuery() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return ConcreteQuery;
}(Query));
exports.ConcreteQuery = ConcreteQuery;
