"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var httpModule = require("./http");
var cookies = require("./cookies");
function urlId(url, id) {
    return url + "/" + id;
}
/**Represent a RESTful http resource */
var Resource = /** @class */ (function () {
    /**
     * @param url Url del servicio
     * @param http Servicio de peticiones HTTP, si no se especifica se usara el servicio HTTP por default
     */
    function Resource(url, enableMemoize, http) {
        var _this = this;
        /**Query a collection of entities */
        this.Query = function (params) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.enableMemoize) return [3 /*break*/, 1];
                        return [2 /*return*/, cookies.cookieNetworkMemoize(this.http.Get, "resource")(this.url, params)];
                    case 1: return [4 /*yield*/, this.http.Get(this.url, params)];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        }); };
        /**Get a single entity */
        this.Get = function (id, params) { return __awaiter(_this, void 0, void 0, function () {
            var url;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        url = urlId(this.url, id);
                        if (!this.enableMemoize) return [3 /*break*/, 1];
                        return [2 /*return*/, cookies.cookieNetworkMemoize(this.http.Get, "resource")(url, params)];
                    case 1: return [4 /*yield*/, this.http.Get(url, params)];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        }); };
        /**Insert a single entity. Return the entity id */
        this.Insert = function (entity, params) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.http.Post(this.url, entity, params)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        }); };
        /**Update an entity */
        this.Update = function (id, entity, params) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.http.Put(urlId(this.url, id), entity, params)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        }); };
        /**Delete an entity */
        this.Delete = function (id, params) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.http.Delete(urlId(this.url, id), params)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        }); };
        this.http = http || httpModule.Http;
        this.url = url;
        this.enableMemoize = !!enableMemoize;
    }
    Resource.prototype.networkMemoize = function () {
        return {
            Query: cookies.cookieNetworkMemoize(this.Query, "query_" + this.url),
            Get: cookies.cookieNetworkMemoize(this.Get, "get_" + this.url),
            Insert: this.Insert,
            Update: this.Update,
            Delete: this.Delete
        };
    };
    return Resource;
}());
exports.Resource = Resource;
