"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var http_1 = require("./http");
/**Crea un objecto para consumir un servicio RPC, en donde las peticiones se realizan en la forma:
 * base/controller/method?params=...
 */
exports.rpcService = function (baseUrl) { return function (controller) { return function (method, verb) {
    if (verb === void 0) { verb = "POST"; }
    return function (params, body) {
        return http_1.Http.HttpJson({
            body: body,
            headers: undefined,
            method: verb,
            url: baseUrl + "/" + controller + "/" + method,
            urlParameters: params
        });
    };
}; }; };
/**
 * Devuelve un crud service para un servicio RPC-POST con la siguiente firma:
 * Get(id : number) => T;
 * Query() => T[];
 * Add(entity: T) => number;
 * Update(entity: T) => number;
 * Delete(id: number) => void;
 *
 * Si su servicio no conforma con esta forma es mejor usar directamente los metodos rpcService.
 * Si el resultado del Update del controllador no devuelve un numero se devuelve el valor de la propiedad IdRegistro del parametro de la función
 */
function rpcCrudService(controller) {
    var _this = this;
    return {
        get: function (id) { return controller("Get")({ id: id }); },
        query: function () { return controller("Query")({}); },
        add: function (entity) { return controller("Add")({}, entity); },
        update: function (entity) { return __awaiter(_this, void 0, void 0, function () {
            var ret;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, controller("Update")({}, entity)];
                    case 1:
                        ret = _a.sent();
                        return [2 /*return*/, ret || entity.IdRegistro];
                }
            });
        }); },
        delete: function (id) { return controller("Delete")({ id: id }); }
    };
}
exports.rpcCrudService = rpcCrudService;
