/// <reference types="react" />
import React = require("react");
export interface Vector2 {
    x: number;
    y: number;
}
export declare type Stroke = Vector2[];
export interface SignaturePadProps {
    /**Firma que se va a mostrar */
    value: Stroke[];
    /**Se dispara cada vez que se cambia la firma */
    onChange?: (value: Stroke[]) => void;
    /**True para encajar la firma al tamaño del canvas*/
    zoomToFit?: boolean;
}
/**Elemento editor de una firma */
export declare class SignatureCanvas extends React.Component<SignaturePadProps, {}> {
    handleCanvas: (canvas: HTMLCanvasElement | null) => void;
    componentWillUnmount(): void;
    private drawer;
    onResize: () => void;
    componentWillReceiveProps(props: SignaturePadProps): void;
    handleStroke: (stroke: Vector2[]) => void;
    /**Dibuja los strokes */
    refresh(props: SignaturePadProps): void;
    canvas?: HTMLCanvasElement;
    private setCanvasSize();
    render(): JSX.Element;
}
