import { Tree, TreePath } from "./types";
import { TreePathArray, CollapsedType } from "./treeState";
export interface TreeRow<T> {
    /**Ruta completa de este row */
    path: TreePath;
    /**Si el row esta collapsado o no, o si no se puede colapsar */
    collapsed: CollapsedType;
    /**Valor del row */
    value: T;
}
/**Obtiene todas las filas que se van a mostrar en un tree */
export declare function getTreeRows<T>(basePath: TreePath, tree: Tree<T>[], collapsedPaths: TreePathArray): TreeRow<T>[];
/**Devuelve el nuevo valor para el arreglo de elementos colapsados dada la ruta y el valor de colapsado de un evento de colapsar o expandir */
export declare function handleOnCollapsedChange(path: TreePath, value: boolean, oldValue: TreePathArray): TreePathArray;
/**Devuelve true si una ruta del arbol esta colapsada */
export declare function isCollapsed(path: TreePath, collapsedArray: TreePathArray): boolean;
/**Devuelve true si 2 secuencias contienen a los mismos elementos */
export declare function sequenceEquals<T>(a: T[], b: T[]): boolean;
/**Devuelve true si algun elemento encaja con el predicado */
export declare function any<T>(array: T[], pred: (value: T) => boolean): boolean;
