"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
/**Tamaño de una unidad de indentación en pixeles */
var indentUnitSize = 20;
var CollapsedIcon = /** @class */ (function (_super) {
    __extends(CollapsedIcon, _super);
    function CollapsedIcon() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CollapsedIcon.prototype.render = function () {
        var i = this.props.collapsed == "collapsed" ? "plus-" :
            this.props.collapsed == "expanded" ? "minus-" :
                this.props.collapsed == "leaf" ? "" : this.props.collapsed;
        var icon = "fa fa-" + i + "square-o fa-fw";
        return React.createElement("i", { className: icon });
    };
    return CollapsedIcon;
}(React.PureComponent));
/**Dibuja una fila del arbol. El contenido de la fila será el contenido  */
var TreeRowComponent = /** @class */ (function (_super) {
    __extends(TreeRowComponent, _super);
    function TreeRowComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TreeRowComponent.prototype.render = function () {
        var props = this.props;
        return (React.createElement("div", { style: { display: "flex" } },
            React.createElement("div", { style: { width: (indentUnitSize * props.level) + "px" } }),
            React.createElement("div", { onClick: props.collapsed != "leaf" ? (function () { return props.onCollapsedChange(props.collapsed != "collapsed"); }) : undefined },
                React.createElement(CollapsedIcon, { collapsed: props.collapsed })),
            React.createElement("div", null, this.props.children)));
    };
    return TreeRowComponent;
}(React.PureComponent));
exports.TreeRowComponent = TreeRowComponent;
