"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var botones_1 = require("./botones");
function hideInput(el) {
    el.style.position = 'absolute';
    el.style.top = "0";
    el.style.left = "0";
    el.style.width = "0";
    el.style.height = "0";
    el.style.display = "none";
}
/**Obtiene un arreglo con los archivos seleccionados en un input. Devuelve null si no se seleccionó ningun archivo */
function getFiles(input) {
    if (!input.files || input.files.length == 0)
        return null;
    var multi = input.multiple;
    var inputFiles = input.files;
    var fileArray = [];
    for (var i = 0; i < inputFiles.length; i++) {
        fileArray.push(inputFiles[i]);
    }
    return fileArray;
}
function upload(multi) {
    //Creamos un elemento input escondido:
    var input = document.createElement("input");
    input.type = "file";
    hideInput(input);
    input.multiple = multi || false;
    //Lo agregamos al documento:
    document.body.appendChild(input);
    return new Promise(function (resolve) {
        input.onchange = function (ev) {
            var files = getFiles(input);
            var ret = files && (multi ? files : files[0]);
            //Quitamos el input del documento:
            document.body.removeChild(input);
            resolve(ret);
        };
        /**Bandera que indica si se debe de revisar si el input se cancelo, esto porque sólo se debe de hacer una vez */
        var checkCancel = true;
        function onBodyFocus() {
            if (!checkCancel)
                return;
            checkCancel = false;
            document.body.removeEventListener("focus", onfocus);
            //Realizamos el chequeo con un retraso, si lo revisamos inmediatamente el valor de input.value aun no
            //estará actualizado
            setTimeout(function () {
                if (!input.value) {
                    //El usuario no seleccionó ningún archivo
                    resolve(null);
                }
            }, 100);
        }
        document.body.addEventListener("focus", onBodyFocus, true);
        input.click();
    });
}
exports.upload = upload;
/**Esta clase sirve para mostrar un botón que nos permite abrir un filechooser y regresa un arreglo de tipo File
 * @deprecated Utilice en lugar de este componente un Button y la función upload()
 */
var Upload = /** @class */ (function (_super) {
    __extends(Upload, _super);
    function Upload(props) {
        var _this = _super.call(this, props) || this;
        _this.handleInput = function (input) {
            if (input) {
                _this.input = input;
            }
        };
        _this.handleOnChangeAsync = function (files) { return __awaiter(_this, void 0, void 0, function () {
            var ret, i;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.props.onChange)
                            return [2 /*return*/];
                        if (!files || files.length == 0)
                            return [2 /*return*/];
                        ret = [];
                        for (i = 0; i < files.length; i++) {
                            ret.push(files.item(i));
                        }
                        return [4 /*yield*/, this.props.onChange(ret)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); };
        _this.handleOnChange = function (a) {
            _this.handleOnChangeAsync(_this.input.files);
            _this.input.value = null;
            return false;
        };
        _this.handleOnClick = function () {
            _this.input.click();
        };
        console.warn("@deprecated Utilice en lugar del componente <Upload /> un <Button /> y la función upload()");
        return _this;
    }
    Upload.prototype.render = function () {
        var esconder = {
            position: 'absolute',
            top: 0,
            left: 0,
            width: 0,
            height: 0,
            display: "none"
        };
        return (React.createElement("div", { style: { position: "relative", backgroundColor: "white" } },
            React.createElement("input", { type: "file", onChange: this.handleOnChange, style: esconder, multiple: this.props.multiple, ref: this.handleInput }),
            React.createElement(botones_1.Button, { onClick: this.handleOnClick, disabled: this.props.disabled, iconClass: this.props.iconClass || "fa fa-upload", style: this.props.style || "info", tooltip: this.props.tooltip }, this.props.children || "Buscar archivo")));
    };
    return Upload;
}(React.Component));
exports.Upload = Upload;
