export declare type UrlParameterScalar = string | number | Date | boolean;
export declare type UrlParameterScalarNull = UrlParameterScalar | null | undefined;
export declare type UrlParamValue = UrlParameterScalarNull | UrlParameterScalarNull[];
export declare type UrlParameters<Keys extends string> = {
    [key in Keys]?: UrlParamValue;
};
/**Codifica el valor de un query parameter*/
export declare function encodeUrlParameterValue(parameter: UrlParameterScalar): string;
/**Devuelve una cadena con todos los parametros url, separador por &. El caracter ? inicial no se devuelve por esta función. Si no hay ningun
 * parámetro que devolver se devuelve una cadena vacia
 */
export declare function encodeUrlParameters<TParams extends UrlParameters<keyof TParams>>(urlParameters: TParams): string;
/**
 * Pega los parametros ya codificados a una URL con el separador ?. Si parameters esta vacio devuelve la URL original tal cual
 */
export declare function appendEncodedUrlParameters(url: string, paramStr: string): string;
