"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var keautils_1 = require("keautils");
function resultIsError(value) {
    if (!value)
        return true;
    if (value == true)
        return false;
    return true;
}
/**Determina si un resultado de validación tiene errores */
function hasError(validation) {
    return __awaiter(this, void 0, void 0, function () {
        var val, ret;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, keautils_1.promiseAllObj(validation)];
                case 1:
                    val = _a.sent();
                    ret = keautils_1.any(keautils_1.enumObject(val), function (x) { return x.value != null; });
                    return [2 /*return*/, ret];
            }
        });
    });
}
exports.hasError = hasError;
/**Evalua un conjunto de reglas de validación dado un objeto */
function getErrors(rules, value) {
    var _this = this;
    var result = keautils_1.pipe(rules, function (curr) { return keautils_1.mapObject(curr, function (prop, key) { return prop ? prop(value, key) : true; }); }, function (curr) { return keautils_1.mapObject(curr, function (prop) { return __awaiter(_this, void 0, void 0, function () {
        var pVal;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, prop];
                case 1:
                    pVal = _a.sent();
                    return [2 /*return*/, !(pVal) ? "error" : //Si prop evalua a falso, es error
                            (pVal) === true ? undefined : //Si prop === true, no es error
                                (pVal)];
            }
        });
    }); }); });
    return result;
}
exports.getErrors = getErrors;
/**Devuelve la cadena "Valor requerido" si value es null o undefined, si no devuelve true*/
function required(value, key) {
    var val = (value && value[key]);
    return (val == null || val == "") ? "Valor requerido" : true;
}
exports.required = required;
/**
 * Devuelve un nuevo conjunto de reglas el cual sólo valida a errores cuando se cumple la condición, es decir, si la condición no se cumple, el nuevo conjunto de reglas no devuelve errores
 * @param rules Conjunto de reglas base
 * @param condition Condición tal que sólo permitirá devulver errores si es true
 */
function when(condition, rules) {
    if (condition === true) {
        return rules;
    }
    else if (condition === false) {
        return {};
    }
    else {
        return keautils_1.mapObject(rules, function (rule) { return rule && (function (value, key) { return condition(value) ? rule(value, key) : true; }); });
    }
}
exports.when = when;
/**
 * Devuelve un nuevo conjunto de reglas que es el AND entre dos conjuntos de reglas
 * @param a
 * @param b
 */
function and2(a, b) {
    function resultAnd(a, b) {
        if (a === true && b === true)
            return true;
        if (typeof a == "string" && typeof b == "string")
            return a + ", " + b;
        if (typeof a == "string")
            return a;
        if (typeof b == "string")
            return b;
        else
            return a || b;
    }
    function ruleAnd(a, b) {
        var _this = this;
        return function (value, key) { return __awaiter(_this, void 0, void 0, function () {
            var aProm, bProm, race, _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        aProm = Promise.resolve(a(value, key));
                        bProm = Promise.resolve(b(value, key));
                        return [4 /*yield*/, Promise.race([aProm, bProm])];
                    case 1:
                        race = _c.sent();
                        if (!resultIsError(race)) return [3 /*break*/, 2];
                        return [2 /*return*/, race];
                    case 2:
                        _a = resultAnd;
                        return [4 /*yield*/, aProm];
                    case 3:
                        _b = [_c.sent()];
                        return [4 /*yield*/, bProm];
                    case 4: return [2 /*return*/, _a.apply(void 0, _b.concat([_c.sent()]))];
                }
            });
        }); };
    }
    var keys = keautils_1.union(Object.keys(a), Object.keys(b));
    var values = keautils_1.arrayToMap(keys.map(function (key) {
        var aRule = a[key];
        var bRule = b[key];
        var value = aRule && bRule ? ruleAnd(aRule, bRule) :
            aRule || bRule;
        return { key: key, value: value };
    }));
    return values;
}
/**
 * Devuelve un nuevo conjunto de reglas que es el AND entre dos conjuntos de reglas
 */
function and() {
    var rules = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        rules[_i] = arguments[_i];
    }
    return rules.reduce(and2);
}
exports.and = and;
