import React = require("react");
/**Acomoda un conjunto de elementos en un <div /> con varios <div class="row" /> y <div class="col-md-x" /> que tendran a los elementos dados.
 * Los elementos nulos, undefined o false seran ignorados
 */
export function autogrid(columnSize: 12 | 6 | 4 | 3 | 2 | 1, elements: (JSX.Element | null | undefined | false)[]): JSX.Element {
    //Quitar los elementos nulos y falsos
    elements = elements.filter(x => x);

    const maxColumns = 12;
    const columnsPerRow = Math.floor(maxColumns / columnSize);
    const rows = Math.ceil(elements.length / columnsPerRow);

    const ret: JSX.Element[] = [];
    const columnClass = "col-md-" + columnSize;
    let index = 0;
    for (let row = 0; row < rows; row++) {
        const children: JSX.Element[] = [];
        for (let column = 0; column < columnsPerRow; column++) {
            const currentColumn =
                <div className={columnClass}>
                    {elements[index]}
                </div>;

            children.push(currentColumn);
            index++;
        }

        const currentRow = React.createElement("div", { className: "row" }, ...children);
        ret.push(currentRow);
    }

    return React.createElement("div", {}, ...ret);
}