import React = require("react");
import { Link } from "./botones";

export interface BigLinkProps {
    onClick?: () => void;
    label: string;
    description: string;
    icon: string;
}
export class BigLink extends React.PureComponent<BigLinkProps> {
    render() {
        return (
            <div className="panel panel-primary">
                <div className="panel-heading" style={{cursor: "pointer"}} onClick={this.props.onClick}>
                    <span>
                        <i className={this.props.icon } />
                        {this.props.label}
                    </span>
                </div>
                <div className="panel-body" style={{ color: "#0066CC", fontStyle: "italic" }}>
                    {this.props.description}
                </div>
            </div>
        );
    }
}