import swal = require("sweetalert");
import { delay  } from "./async";

/**Muestra un cuadro de dialogo de si y no */
export async function yesno(title: string, text?: string, type?: "warning" | "error" | "success" | "info") {
    const result = await new Promise<boolean>((resolve) => {
        swal({
            title: title,
            text: text,
            type: type,
            showCancelButton: true
        }, isConfirm => resolve(isConfirm))
    });
    //Nos esperamos a que se cierre por completo, esto porque si no al poner varios dialogos seguidos el evento del mouse de uno se toma tambien para el otro
    await delay(200);
    return result;
}

/**Muestra un cuadro de dialogo con un mensaje */
export async function message(title: string, text?: string, type?: "warning" | "error" | "success" | "info") {
    await new Promise<void>((resolve) => {
        swal({
            title: title,
            text: text,
            type: type,
        }, () => resolve());
    });
    await delay(200);
}