import React = require('react');
import { download } from "./downloadjs";
import { BootstrapButtonStyle, Button, Link } from "./botones";
import { Base64ToBlob } from "./files";

/**Un link de descarga ya estilizado */
export class DownloadLink extends React.Component<{ label: string, onClick?: () => void | PromiseLike<void> }, {}> {
    render() {
        return (
            <Link style="link" tooltip="Descargar" iconClass="fa fa-download" onClick={this.props.onClick} >
                {this.props.label}
            </Link>
        )
    }
}

/**Link el cuál realiza la descarga del blob que se le pasa en value */
export class Download extends React.Component<{ value: Blob | string | undefined | null, label: string }, {}> {
    handleClick = async () => {
        const value = this.props.value;
        if (value == null)
            return;
        const blob = typeof (value) == "string" ? Base64ToBlob(value) : value;

        download(blob, this.props.label);
    }

    render() {
        return (
            this.props.value ?
                <DownloadLink label={this.props.label} onClick={this.handleClick} /> :
                <span style={{color: "red"}}>
                    <i className="fa fa-ban" /> No disponible
                </span>
        )
    }
}