/// <reference types="react" />
import React = require("react");
export interface FastInputProps {
    value?: string;
    onChange?: (value: string) => void;
    className?: string;
    disabled?: boolean;
    style?: React.CSSProperties;
    type?: string;
    placeholder?: string;
    multiline?: boolean;
}
/**
 * Un input controlado se vuelve muy lento en android debido a que se estan actualizando constantemente sus
 * propiedades.
 *
 * Este componente envuelve a un input no controlado y solo actualiza su valor cuando es necesario, logrando
 * que se pueda escribir de manera fluida en este en móviles
 */
export declare class FastInput extends React.Component<FastInputProps, {}> {
    handleRef: (input: HTMLInputElement) => void;
    input: HTMLInputElement | null;
    componentWillReceiveProps(newProps: {
        value: string;
    }): void;
    propsCount: number;
    unbouncedRefresh: (value: string) => void;
    changeCount: number;
    lastValue: string;
    private raiseOnChange;
    handleOnChange: (e: React.ChangeEvent<HTMLInputElement>) => void;
    handleBlur: (e: Event) => void;
    /**
     * Establece el valor del input igual al valor de props.value
     * @param value Nuevo valor
     */
    setInputValue(value: string): void;
    render(): React.DetailedReactHTMLElement<any, HTMLElement>;
}
