import React = require("react");
import jsonview = require("../../../jsonview/index");
import { Modal } from "../../../modal";
import { MakeUncontrolled } from "../../../HOC";
export type DialogResult = (string | number)[] | null


export interface DrillObjectProps {
    value: any;
    show: boolean;
    /**Se lanza cuando el usuario cierra el modal o cuando selecciona una propiedad del objeto*/
    onCerrar: (result: DialogResult) => void;

}
export class DrillObjectComponent extends React.PureComponent<DrillObjectProps> {
    private handleOnCerrar = () => this.props.onCerrar(null);
    private handleOnDrill = (path: (string | number)[]) => this.props.onCerrar(path);

    render() {
        const props = this.props;
        return (
            props.show ?
                <Modal
                    buttonsWithKey={[]}
                    onClose={this.handleOnCerrar}
                    title="Ver objeto"
                >
                    <div className="row">
                        <div className="col-md-12">
                             <jsonview.JsonViewComponent value={props.value} onPropClick={this.handleOnDrill} />
                        </div>
                    </div>
                </Modal> : null
        );
    }
}