import React = require("react");
import { Link } from "../../../botones";
import { DrillObjectComponent, DrillObjectProps } from "./drillObjectModal";

export interface ObjectCellProps {
    value: {};

    /**Se llama cuando el usuario desea agregar una columna de este objeto */
    onDrillDown: (path: (string | number)[]) => void;
}
export  interface ObjectCellState {
    showDrillModal?: boolean;
}
export class ObjectCell extends React.PureComponent<ObjectCellProps, ObjectCellState>{
    constructor(props) {
        super(props);
        this.state = {};
    }
    private onModalCerrar = (path: ((string | number)[]) | null) => {
        if (path != null) {
            this.props.onDrillDown(path);
        }
        this.setState({ showDrillModal: false });
    };

    render() {
        const keys = Object.keys(this.props.value);
        const { props, state } = this;
        return (
            <span>
                <Link style="success" iconClass="fa fa-list-alt" onClick={() => this.setState({ showDrillModal: true })} />
                {keys.map(key => <Link style="info" key={key} onClick={() => props.onDrillDown([key])}  >{key}</Link>)}
                <DrillObjectComponent
                    show={!!state.showDrillModal}
                    value={props.value}
                    onCerrar={this.onModalCerrar}
                />
            </span>
        );
    }
}