import React = require("react");
import { Key } from "../simpleGrid/baseTypes";
import { ColumnMapping } from "../simpleGrid/gridState";
import { createSelector } from "reselect";
import { ColumnMappingComponent } from "./mappingComp";
import { ObjMap } from "keautils";
import { GuardarButton, CancelarButton } from "../../botones";
import { Modal } from "../../modal";
import { message } from "../../dialogs";
export interface Props {
    onExportar: () => Promise<void>;
    onCerrar: () => void;

    mapping: ColumnMapping;
    onMappingChange: (value: ColumnMapping) => void;
    columnas: ObjMap<string>;

}
export class ExportComp extends React.PureComponent<Props> {
    private onGuardar = async () => {
        await this.props.onExportar();
        await message("Exportación terminada", "", "success");
        this.props.onCerrar();
    }

    render() {
        return (
            <Modal
                title="Exportar a CSV"
                buttonsWithKey={[<GuardarButton key="guardar" onClick={this.onGuardar} />]}
                onClose={this.props.onCerrar}
            >
                <ColumnMappingComponent
                    columnas={this.props.columnas}
                    value={this.props.mapping}
                    onChange={this.props.onMappingChange}
                />
            </Modal>

        );
    }
}