import React = require("react");
import { Number, Text, DateTime } from "../../fields/fields";
import { GridColumnFilterComponentProps, GridColumnFilter } from "../simpleGrid/tiposFiltros";
import { Link } from "../../botones";
import { handleFormChange } from "../../form";
import { CellData } from "../simpleGrid/baseTypes";
import { compare } from "../simpleGrid/filtrarOrdenar";
import { cellToText } from "../simpleGrid/text";
import { search } from "../../search";

export interface FiltroPorBusquedaTexto {
    busqueda?: string;
}

function filter(item: CellData, data: FiltroPorBusquedaTexto, string: string) {
    return search(data.busqueda, string);
}

class FiltroBusquedaComponent extends React.PureComponent<GridColumnFilterComponentProps<any, FiltroPorBusquedaTexto>> {
    render() {
        const props = this.props;
        const value = props.value || {};
        const busqueda = value.busqueda || "";
        const titulo = props.titulo;
        const label = <span><Link iconClass="fa fa-times" onClick={props.onQuitar} /> <label>{titulo}</label></span>;
        return (
            <div>
                <Text addon={<i className="fa fa-search" />} placeholder="Búsqueda" label={label} value={busqueda} onChange={x => props.onChange({ busqueda: x })} />
            </div>
        )
    }
}

export const filtro: GridColumnFilter<FiltroPorBusquedaTexto> = {
    component: FiltroBusquedaComponent,
    filter: (item, data, string) => filter(item, data, string)
}