import React = require("react");
import { Number, Text, DateTime } from "../../fields/fields";
import { GridColumnFilterComponentProps, GridColumnFilter, ItemRowData } from "../simpleGrid/tiposFiltros";
import { Link } from "../../botones";
import { handleFormChange } from "../../form";
import { busquedaRango } from "./rango";
import { CellData } from "../simpleGrid/baseTypes";
export interface FiltroRangoFechas {
    inicio?: Date | null;
    final?: Date | null;
}

function filter(item: CellData, data: FiltroRangoFechas) {
    const min = data.inicio;
    const max = data.final;
    const itemValue = item && item.valueOf && ((item as Date).valueOf() as any) || undefined;
    const itemValueNumber = typeof itemValue == "number" && itemValue || undefined;
    return busquedaRango(min && min.valueOf(), max && max.valueOf(), itemValueNumber);
}

function FiltroRangoFechasComponent<TItem>(props: GridColumnFilterComponentProps<TItem, FiltroRangoFechas>) {
    const x = props.value || {};
    const change = handleFormChange(() => props);
    return (
        <div>
            <div className="col-md-6">
                <DateTime value={x.inicio} label={<span><Link iconClass="fa fa-times" onClick={props.onQuitar} /> <label>{props.titulo + " inicio"}</label></span>} onChange={change("inicio")} />
            </div>
            <div className="col-md-6">
                <DateTime value={x.final} label={props.titulo + " final"} onChange={change("final")} />
            </div>
        </div>
    );
}

/**Filtro ppr rango de fechas */
export const filtro: GridColumnFilter<FiltroRangoFechas> = {
    component: FiltroRangoFechasComponent,
    filter: (item, data) => filter(item, data)
};
