import { CellData, GridCell, Key, CellView } from "./baseTypes";
import { GridColumnFilter } from "./tiposFiltros";

export interface Grid2Column<TItem = any, TShared = undefined> {
    /**Titulo de la columna*/
    title: string;
    /**Clave que identifica únicamente a esta columna. Si no se establece se tomara como el titulo a la clave de la columna */
    key?: Key

    /**Filtro que se va a usar en esta columna*/
    filter?: GridColumnFilter<any>;

    /**Función que obtiene el contenido de la columna dado el objeto en esta fila. La función toma dos parametros, el primero es la fila
     * y el segundo los datos compartidos por todos los items
    */
    cell: (row: TItem) => GridCell<any, TShared>;

}

export interface ColumnMap {
    [k: string]: Grid2Column<any, any>;
}