import { Tree } from "../treeview/index";
export declare type JsonTreeView = Tree<JsonValue>;
export declare type SimpleValue = string | number | boolean;
export declare type JsonNodeType = "string" | "number" | "boolean" | "null" | "object" | "function" | "array";
/**Convierte un objeto a un arbol que se puede visualizar con el tree view */
export declare function valueToJsonTreeView(obj: any): JsonTreeView;
export interface JsonValue {
    value: SimpleValue | null;
    type: JsonNodeType;
    /**Determina la naturaleza de los hijos de este elemento*/
    tree: "leaf" | "object" | "array";
    /**Cantidad de hijos */
    count: number;
}
