import * as React from "react";
import { JsonTreeView, JsonValue } from "./logic";
import { Link } from "../botones";

export interface NodeProps {
    propname: string | number;
    value: JsonValue;
    onClick?: () => void;
}
export class JsonNodeComponent extends React.PureComponent<NodeProps> {
    render() {
        const x = this.props.value;
        const key = this.props.propname;
        return (
            <span>
                {(key != null && key != "") &&
                    <span style={{ fontWeight: "bold", color: "#231858" }}>
                        {<Link style="info" onClick={this.props.onClick} >{key}</Link>}{": "}
                    </span>
                }
                {
                    x.value != null &&
                    <span style={{ color: "#9B344E" }}>
                        {x.type == "string" ? ("\"" + x.value + "\"") : ("" + x.value)}
                    </span>}
            </span>
        )
    }
}
