/// <reference types="react" />
import React = require('react');
/**Propiedades de un modal */
export interface DialogProps {
    /**Titulo del cuadro de dialogo*/
    title: any;
    /**Ocurre cuando el dialogo es cerrado */
    onClose?: () => void;
    /**Botones del cuadro de dialogo. Ponga aqui los botones del mismo */
    buttonsWithKey?: JSX.Element | JSX.Element[];
    fullScreen?: boolean;
}
/**Componente que muestra un cuadro de dialogo. Establezca como hijos el cuerpo del dialogo */
export declare class Modal extends React.Component<DialogProps, {}> {
    private modalDiv;
    constructor(props: DialogProps);
    private lastModalState;
    private onDialogClick;
    render(): JSX.Element;
}
export interface BorrarModalProps {
    /**Nombre de la entidad que se va a borrar*/
    entityName: string;
    /**Nombre del tipo de entidad que se va a borrar */
    entityTypeName: string;
    /**Accion que se va a ejecutar al borrar el modal */
    onDelete?: () => PromiseLike<void> | void;
    /**Accion que se ejecuta al cerrar el cuadro de dialogo */
    onClose?: () => void;
}
/**Modal para borrar un elemento */
export declare class BorrarModal extends React.Component<BorrarModalProps, {}> {
    constructor(props: any);
    handleOnDelete: () => Promise<void>;
    render(): JSX.Element;
}
