import React = require("react");

export type ColumnDefinition<props> = [string | JSX.Element, (x: props, key: string | number) => (string | number | JSX.Element)];

function wrapJSX(value: string | number | JSX.Element | null | undefined, wrap: (value: string | number | null | undefined) => JSX.Element) {
    if (typeof (value) == "string" || typeof (value) == "number" || value == null) {
        return wrap(value);
    } else {
        return value;
    }
}

function wraptd(value: string | number | JSX.Element, key: string | number) {
    return wrapJSX(value, x => <td key={key}>{x}</td>);
}

function wrapth(value: string | number | JSX.Element, key: string | number) {
    return wrapJSX(value, x => <th key={key}>{x}</th>);
}


/**Devuelve el elemento de una cabecera de una tabla dada la definicion de las columnas */
export function HeaderFromColumns(definition: ColumnDefinition<any>[]): JSX.Element[] {
    return definition.map((x, i) => wrapth(x[0], i));
}

//TODO: Hay que memoizar esta función:
/**Devuelve las celdas que forman a la fila de una tabla*/
export function RowFromColumns<TProps>(definition: ColumnDefinition<TProps>[], props: TProps): JSX.Element[] {
    return definition.map(x => x[1]).map((x, i) => x(props, i)).map(wraptd);
}
