import * as React from "react";
import { CollapsedType } from "./treeState";
import { TreePath } from "./types";
/**Tamaño de una unidad de indentación en pixeles */
const indentUnitSize = 20;

export interface RowComponentProps {
    key: string;
    value: any;
    path: TreePath;
    level: number;
    collapsed: CollapsedType;
    onCollapsedChange: (value: boolean) => void;
}

class CollapsedIcon extends React.PureComponent<{ collapsed: CollapsedType }> {
    render() {
        const i =
            this.props.collapsed == "collapsed" ? "plus-" :
                this.props.collapsed == "expanded" ? "minus-" :
                    this.props.collapsed == "leaf" ? "" : this.props.collapsed;

        const icon = `fa fa-${i}square-o fa-fw`;

        return <i className={icon} />
    }
}

/**Dibuja una fila del arbol. El contenido de la fila será el contenido  */
export class TreeRowComponent extends React.PureComponent<RowComponentProps> {
    render() {
        const props = this.props;
        return (
            <div style={{ display: "flex" }} >
                <div style={{ width: (indentUnitSize * props.level) + "px" }} />
                <div onClick={props.collapsed != "leaf" ? (() => props.onCollapsedChange(props.collapsed != "collapsed")) : undefined}>
                    <CollapsedIcon collapsed={props.collapsed} />
                </div>
                <div>
                    {this.props.children}
                </div>
            </div>
        )
    }
}