/// <reference types="react" />
import React = require('react');
import { BootstrapButtonStyle } from "./botones";
export interface UploadProps {
    onChange?: (value: File[]) => Promise<void> | void;
    disabled?: boolean;
    tooltip?: string;
    /**True para seleccionar multiples archivos */
    multiple?: boolean;
    /**Estilo del botón de bootstrap. Por default es "default" */
    style?: BootstrapButtonStyle;
    /**Clase del icono o indefinido para no mostrar un icono */
    iconClass?: string;
}
/**Muestra el selector de archivos y devuelve el archivo seleccionado o null si no hay archivo */
export declare function upload(): Promise<File | null>;
/**Muestra el selector de archivos y devuelve el archivo seleccionado o null si no hay archivo */
export declare function upload(multi: false): Promise<File | null>;
/**Muestra el selector de archivos y devuelve los archivos seleccionados o null si no hay archivos */
export declare function upload(multi: true): Promise<File[] | null>;
/**Esta clase sirve para mostrar un botón que nos permite abrir un filechooser y regresa un arreglo de tipo File
 * @deprecated Utilice en lugar de este componente un Button y la función upload()
 */
export declare class Upload extends React.Component<UploadProps, {}> {
    constructor(props: any);
    input: HTMLInputElement;
    handleInput: (input: HTMLInputElement | null) => void;
    handleOnChangeAsync: (files: FileList | null) => Promise<void>;
    handleOnChange: (a: React.ChangeEvent<HTMLInputElement>) => boolean;
    handleOnClick: () => void;
    render(): JSX.Element;
}
