import * as React from "react";
import * as DOM from "react-dom";
import { Entity, rows } from "./data";

import { Grid2, Grid2Column, Grid2Props, Grid2State, filtros, arrayCell } from "../src/grid2Base/index";
import { Button } from "../src/botones";
import { Hours } from "../src/fields/hour";
import { upload } from "../src/upload";
import { BlobToBase64 } from "../src/files";
import { DateTime } from "../src/fields/datetime";
import { mailto } from "../src/mailto";
import { Phone, Text } from "../src/fields/fields";
import { MiModal } from "./modal";

import "./style.less";
import { createModalManager } from "../src/modals/modalmanager";
const columns: Grid2Column<Entity, undefined>[] = [
    {
        key: "a2",
        title: "Nombre",
        cell: x => {
            console.log("Nombre get data");
            return { data: x.nombre };
        },
    }, {
        key: "b2",
        title: "Edad",
        cell: x => ({ data: x.edad }),
    }, {
        key: "arr1_",
        title: "Arr1",
        cell: x => ({
            data: x.strArray, string: (x.strArray || []).join("|"),
            view: arrayCell()
        }),
    }, {
        key: "arr2",
        title: "Arr2",
        cell: x => ({
            data: x.objArray,
            view: arrayCell({
                columns: [
                    { title: "a", cell: x => "" + x.a },
                    { title: "b", cell: x => "" + x.b }
                ],
            })
        }),
    }, {
        key: "c",
        title: "Fecha",
        cell: x => ({ data: x.fecha }),
    }, {
        key: "d",
        title: "Objeto",
        cell: x => ({ data: x })
    }, {
        key: "botones",
        title: "",
        cell: x => ({ data: 0 })
    }
];


export class Home extends React.Component<{}, { text: string, fecha: Date | null }> {
    constructor(props) {
        super(props);
        this.state = {
            text: "",
            fecha: new Date()
        };
    }

    private manager = createModalManager();
    private get modalManager() {
        return this.manager.component;
    }
    private get showModal() {
        return this.manager.showModal;
    }

    private handleModal = async () => {
        const result = await this.showModal(MiModal, { titulo: "Mi titulo" }, {});
        alert("El resultado del modal es: " + result.result + " y el valor string es: " + result.value);
    }

    private handleOnSubirArchivo = async () => {
        const archivo = await upload();
        if (archivo) {
            var text = await BlobToBase64(archivo);
        }
    }

    render() {
        return (
            <div>
             
                <DateTime value={this.state.fecha} onChange={x => this.setState({fecha: x})} time />
               
            </div>
        );
    }
}

DOM.render(<Home />, document.getElementById("root"));