import * as React from "react";
import { Modal } from "../src/modal";
import { Button } from "../src/botones";
import { Text } from "../src/fields/fields";
export interface Props {
    params: { titulo: string };
    value: string;
    onChange: (value: string) => void;
    onClose: (result: boolean) => void;
}

export class MiModal extends React.PureComponent<Props> {
    render() {
        return <Modal
            title={this.props.params.titulo}
            onClose={() => this.props.onClose(false)}
            buttonsWithKey={[<Button onClick={() => this.props.onClose(true)} >Ok</Button>]}
        >
            <Text label="Mi texto" value={this.props.value} onChange={this.props.onChange} />
        </Modal>
    }
}